var subforharm = 
[1, 1, 1, 2, 4, 4, 4, 4, 4, 8, 8, 8, 8,  8, 8, 8, 16, 16, 16, 32];
var harmforsub = 
[1, 1, 1, 4, 4, 8, 8, 8, 8, 16, 16, 16, 16, 16, 16, 16, 16, 32, 32, 32];
	
inlets = 3;
outlets = 2;

var fundamental = 523;
var octaveshift = 0;

// amount of random subtraction permitted (up to table value)

function enable_shift(n)
{
	octaveshift = n;
}

function msg_int(n)
{
	var n2, o2, sf;

	if (inlet == 0) { // harmonic
		if (n < 0)
			n = 0;
		if (n > 19)
			n = 19;
		n2 = fundamental * n;
		o2 = subforharm[n];
		if (octaveshift) {
			sf = Math.floor(Math.random() * octaveshift);
			for (i = 0; i < sf; i++) {
				if (o2 > 1)
					o2 /= 2;
				else
					break;
			}
		}
		n2 /= o2;
		outlet(0,n2);
	} else if (inlet == 1) {	// subharmonic
		if (n < 0)
			n = 0;
		if (n > 19)
			n = 19;
		n2 = fundamental / n;
		o2 = harmforsub[n];
		if (octaveshift) {
			sf = Math.floor(Math.random() * octaveshift);
			for (i = 0; i < sf; i++) {
				if (o2 > 1)
					o2 *= 2;
				else
					break;
			}
		}
		n2 *= o2;
		outlet(1, n2);
	} else if (inlet == 2)	{	// fundamental
		fundamental = n;
	}
}

	